;----------------------------------------------------------------------------
;				DLL.asm
;----------------------------------------------------------------------------
.386
.model flat,stdcall
option casemap:none
include \tools\masm32\include\windows.inc
include \tools\masm32\include\user32.inc
include \tools\masm32\include\kernel32.inc

includelib \tools\masm32\lib\user32.lib
includelib \tools\masm32\lib\kernel32.lib

;===============================================================================;
;			Initialized Data Section				;
;===============================================================================;
.data										;
	kernelName db "kernel32.dll",0; Kernel32.dll				;
	nt db "user32.dll",0							;
	Exitstr db "MessageBoxW",0						;
	Exitstr1 db "MessageBoxA",0
	not1 db ":",13,10,",    y-   10 .",13,10,"     y,   .",13,10,"-   ?",13,10,"-   ,   10,    9...",13,10,"-  ???",13,10,"- Hy   : 0, 1, 2, ...",13,10,"  ,    ? ;)",0
	not2 db " ;)",0						;
	ModEntry MODULEENTRY32 <0>						;
;===============================================================================;
.code
DllEntry proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD
	.if reason==DLL_PROCESS_ATTACH
		pushad
		invoke GetModuleHandle,offset nt;   Kernel32.dll
		invoke GetProcAddress,eax,offset Exitstr
		push offset start
		push eax
		push offset nt
		call EditIATGlobal

		invoke GetModuleHandle,offset nt;   Kernel32.dll
		invoke GetProcAddress,eax,offset Exitstr1
		push offset start
		push eax
		push offset nt
		call EditIATGlobal
		popad
	.elseif reason==DLL_PROCESS_DETACH

	.elseif reason==DLL_THREAD_ATTACH

	.else        ; DLL_THREAD_DETACH

	.endif
	mov  eax,TRUE
	ret
DllEntry Endp
;===============================================================================;
; EditIATLocal							
;:
;    IAT   
;: Address     
;	ModName     , IAT    .   .
;	Orig   ,  
;	New -   
;	ModHandle   ,     . ,  KERNEL32.DLL
;: 1 - , 0 -      
;===============================================================================;
EditIATLocal proc ModName:DWORD, Orig:DWORD, New:DWORD, ModHandle:DWORD
LOCAL OldProtect:DWORD
;   
	mov eax,ModHandle
	assume eax:ptr IMAGE_DOS_HEADER
	add eax,[eax].e_lfanew
	add eax,4
	add eax,sizeof IMAGE_FILE_HEADER	
	mov edi,eax
	assume edi:ptr IMAGE_OPTIONAL_HEADER
	lea edi,[edi].DataDirectory
	mov eax,edi
;   
	assume eax:ptr IMAGE_DATA_DIRECTORY
	lea eax,[eax+(sizeof IMAGE_DATA_DIRECTORY)*IMAGE_DIRECTORY_ENTRY_IMPORT]
	.IF dword ptr [eax]==0 
		ret;  
	.ENDIF
	mov esi,ModHandle
	add esi,dword ptr [eax]; esi -   
	assume esi:PTR IMAGE_IMPORT_DESCRIPTOR
NextDLL:;    
	.IF [esi].Name1==NULL;  ?
		mov eax,FALSE
		ret
	.ENDIF 
	mov ecx,[esi].Name1
	add ecx,ModHandle
	invoke lstrcmpi,ModName,ecx;   ?
	.IF EAX!=0
		add esi,sizeof IMAGE_IMPORT_DESCRIPTOR
		jmp NextDLL
	.ENDIF
;   ,    
	mov edi,ModHandle
	add edi,[esi].FirstThunk; EDI - IAT
	assume edi:PTR IMAGE_THUNK_DATA
NextFunction:;   
	.IF [edi].u1.Function==0;IAT 
		add esi,sizeof IMAGE_IMPORT_DESCRIPTOR
		jmp NextDLL
	.ENDIF
	mov eax,[edi].u1.Function
	.IF Orig==eax;!!!
		invoke VirtualProtect,edi,4,PAGE_EXECUTE_READWRITE,ADDR OldProtect;    
		call GetCurrentProcess
		mov ecx,eax
		lea eax,New
		invoke WriteProcessMemory,ecx,edi,eax,4,NULL;     
		invoke VirtualProtect,edi,4,OldProtect,ADDR OldProtect;  
		mov eax,TRUE
		ret
	.ENDIF	
	add edi,sizeof IMAGE_THUNK_DATA
	jmp NextFunction
EditIATLocal endp
;===============================================================================;


;===============================================================================;
; EditIATGlobal							
;:
;    IAT    
;: Address     
;	ModName     , IAT    .   .
;	Orig   ,  
;	New -   
;	ModHandle   ,     . ,  KERNEL32.DLL
;: 1 - , 0 -      
;===============================================================================;
EditIATGlobal proc ModName:DWORD, Orig:DWORD, New:DWORD
LOCAL Current:DWORD
LOCAL hSnap:DWORD
	push offset NextMod
	call GetBase
	mov Current,eax;   
	mov ecx,eax
	invoke CreateToolhelp32Snapshot,TH32CS_SNAPMODULE,NULL
	mov hSnap,eax
	mov ModEntry.dwSize,sizeof MODULEENTRY32
	invoke Module32First,hSnap,offset ModEntry
NextMod:
	mov eax,Current
	.IF eax!=ModEntry.hModule;     !
		push ModEntry.hModule
		push New
		push Orig
		push ModName
		call EditIATLocal;   
	.ENDIF
	invoke Module32Next,hSnap,offset ModEntry; 
	.IF eax!=0 
		jmp NextMod
	.ENDIF
	invoke CloseHandle,hSnap
	mov eax,1
	ret
EditIATGlobal endp
;===============================================================================;


;===============================================================================;
; GetBase							
;:
;   ,    -  
;: Address     
;: eax -  PE-
;===============================================================================;
GetBase proc Address:DWORD
	mov eax,FALSE
	mov esi,Address
	and esi,0FFFF0000H;  
	mov ecx,6; 
NextPage:;  
	push esi
	push esi
	call ValidPE
	pop esi
	.IF eax==1
		mov eax,esi
		ret
	.ENDIF
	sub esi,10000H
	loop NextPage
	ret
GetBase endp
;===============================================================================;
;  GetBase
;===============================================================================;


;===============================================================================;
; ValidPE
;:
;  PE-
;: Address -     
;:   ,  eax=1,  eax=0
;===============================================================================;
ValidPE proc Address:DWORD
	mov eax,FALSE
	mov esi,Address
	.IF WORD ptr [esi]=="ZM"
		assume esi:ptr IMAGE_DOS_HEADER; ,   esi   IMAGE_DOS_HEADER
		add esi,[esi].e_lfanew;  PE 
		.IF WORD PTR [esi]=="EP"
			mov eax,TRUE
		.ENDIF
	.ENDIF
	ret
ValidPE endp
;===============================================================================;
;  ValidPE
;===============================================================================;
start PROC x:dword,x1:dword,x2:dword,x3:dword
	invoke MessageBox,x,offset not1,offset not2,x3
	ret
start endp

Test1 proc
	ret	
Test1 endp

End DllEntry
