;#########################################################################
; GetAPIs
;    API-
;:  edi    ASCIIZ   
;	 ebx -       
;	 esi -  kernel32.dll
;	 ecx -   GetProcAddress
;:  
;#########################################################################
GetAPIs proc Number:DWORD
	pushad
	

	mov eax,ecx
	mov ecx,Number
NextFunc:
	push eax
	push esi
	push edi
	push ebx
	push ecx

	push edi; 
	push esi; kernel32
	call eax; GetProcAddress
	
	pop ecx
	pop ebx
	pop edi
	pop esi

	mov dword ptr [ebx],eax;    
	pop eax
	add ebx,4; 
	push ecx; 
	mov ecx,30;  
	push eax
	mov al,0; 0
	repne scasb
	pop eax
	pop ecx
	loop NextFunc
	popad
	ret
GetAPIs endp
;#########################################################################
;  GetAPIs
;#########################################################################

;#########################################################################
; GetGetProcAddress
;   kernel32.dll
;:      "GetProcAddress"
;	ebx -  kernel32.dll
;: eax -   GetProcAddress
;#########################################################################
GetGetProcAddress proc NameFunc:DWORD
	pushad; 
	mov esi,ebx
	assume esi:ptr IMAGE_DOS_HEADER
	add esi,[esi].e_lfanew; esi -  PE

	assume esi:ptr IMAGE_NT_HEADERS
	lea esi,[esi].OptionalHeader; esi -   

	assume esi:ptr IMAGE_OPTIONAL_HEADER
	lea esi,[esi].DataDirectory; esi -  DataDirectory
	mov esi,dword ptr [esi]
	add esi,ebx; esi -  IMAGE_EXPORT_DIRECTORY
	push esi
	assume esi:ptr IMAGE_EXPORT_DIRECTORY
	mov esi,[esi].AddressOfNames
	add esi,ebx; esi -   
	xor edx,edx; edx -  

	mov eax,esi
	mov esi,dword ptr [esi]
NextName:;   
	add esi,ebx
	mov edi,NameFunc
	mov ecx,14;   "GetProcAddress"
	cld
	repe cmpsb
	.IF ecx==0; 
		jmp GetAddr
	.ENDIF
	inc edx
	add eax,4
	mov esi,dword ptr [eax]
	jmp NextName
GetAddr:;  "GetProcAddress"
	pop esi
	mov edi,esi
	mov esi,[esi].AddressOfNameOrdinals
	add esi,ebx; esi -    
	mov dx,word ptr [esi][edx*2]
	assume edi:ptr IMAGE_EXPORT_DIRECTORY
	sub edx,[edi].nBase;  
	inc edx;..     1
	mov esi,[edi].AddressOfFunctions
	add esi,ebx; esi -   
	mov eax,dword ptr [esi][edx*4]
	add eax,ebx; eax -   GetProcAddress
	mov NameFunc,eax
	popad; 
	mov eax,NameFunc
	ret
GetGetProcAddress endp	
;#########################################################################
;  GetGetProcAddress
;#########################################################################

;#########################################################################
; GetKernelImport
;   kernel32.dll
;: 
;: eax -   kernel32.dll
;#########################################################################
GetKernelImport proc
	push esi
	push ebx
	push edi

	call x
x:
	mov esi,dword ptr [esp]; esi -   
	add esp,4; 
	and esi,0FFFF0000h; 
y:
	call ValidPE; EXE-?
	.IF eax==0; ,    
		sub esi,010000h
		jmp y
	.ENDIF

	mov ebx,esi; ebx    
	assume esi:ptr IMAGE_DOS_HEADER
	add esi,[esi].e_lfanew; esi -  PE

	assume esi:ptr IMAGE_NT_HEADERS
	lea esi,[esi].OptionalHeader; esi -   

	assume esi:ptr IMAGE_OPTIONAL_HEADER
	lea esi,[esi].DataDirectory; esi -  DataDirectory

	add esi,8; esi -  1  DataDirectory
	mov eax,ebx
	add eax,dword ptr [esi]; eax -   
	mov esi,eax
	assume esi:ptr IMAGE_IMPORT_DESCRIPTOR
NextDLL:
	mov edi,[esi].Name1
	add edi,ebx
	.IF DWORD PTR [edi]=="NREK";,     : .IF TBYTE PTR [edi]=="LLD.LENREK",       Intel        4 
		;   kernel32!!!
		mov edi,[esi].FirstThunk
		add edi,ebx; edi - VA  IMAGE_THUNK_DATA 	
		mov eax,dword ptr [edi]; eax  -   kernel32.dll
		pop edi
		pop ebx
		pop esi
		ret
	.ENDIF
	add esi,sizeof IMAGE_IMPORT_DESCRIPTOR
	jmp NextDLL
GetKernelImport endp
;#########################################################################
;  GetKernelImport
;#########################################################################

;#########################################################################
; GetKernelSEH
;   kernel32.dll
;: 
;: eax -   kernel32.dll
;#########################################################################
GetKernelSEH proc
	assume fs:flat;  .   assume fs:err
	mov eax,dword ptr fs:[0]; eax -    ERR
NextElem:
	cmp dword ptr [eax],-1; 
	je Yes
	mov eax,dword ptr [eax]
	jmp NextElem
Yes:;    
	mov eax,[eax+4]
	ret
GetKernelSEH endp
;#########################################################################
;  GetKernelSEH
;#########################################################################

;#########################################################################
; GetBase							
;   ,    -  
;:  esi -     
;: eax -  PE-
;:       
;#########################################################################
GetBase proc
LOCAL Base:DWORD;     
	push esi;  ,  
	push ecx

	pushf;  
	and esi,0FFFF0000H;  
	mov ecx,6; 

NextPage:;  
	call ValidPE
	.IF eax==1
		mov Base,esi
		popf
		pop ecx
		pop esi
		mov eax,Base
		ret
	.ENDIF
	sub esi,10000H
	loop NextPage

	popf;  
	pop ecx
	pop esi;  
	mov eax,FALSE;   :(
	ret
GetBase endp
;#########################################################################
;  GetBase
;#########################################################################

;#########################################################################
; ValidPE					
;   PE-
;:  esi -    
;:  ,  eax=1,  eax=0
;:       
;#########################################################################
ValidPE proc
	push esi;  
	pushf;  
	.IF WORD ptr [esi]=="ZM"
		assume esi:ptr IMAGE_DOS_HEADER; ,   esi   IMAGE_DOS_HEADER
		add esi,[esi].e_lfanew;  PE 
		.IF WORD PTR [esi]=="EP"
			popf;  
			pop esi;  
			mov eax,TRUE
			ret
		.ENDIF
	.ENDIF
	popf;  
	pop esi;  	
	mov eax,FALSE
	ret
ValidPE endp
;#########################################################################
;  ValidPE
;#########################################################################