;===============================================================================;
; EditIATGlobal							
;:
;    IAT    
;: Address     
;	ModName     , IAT    .   .
;	Orig   ,  
;	New -   
;	ModHandle   ,     . ,  KERNEL32.DLL
;: 
;===============================================================================;
EditIATGlobal proc ModName:DWORD, Orig:DWORD, New:DWORD,Delta:DWORD
LOCAL Current:DWORD
LOCAL hSnap:DWORD
LOCAL ModEntry:MODULEENTRY32
	startproc
	mov ebx,Delta
	push NULL
	push TH32CS_SNAPMODULE
	apiproc _CreateToolhelp32Snapshot
	mov hSnap,eax
	mov ModEntry.dwSize,sizeof MODULEENTRY32
	lea eax,ModEntry
	push eax
	push hSnap
	apiproc _Module32First
NextMod:
	push ebx
	push ModEntry.hModule
	push New
	push Orig
	push ModName
	call EditIATLocal;   

	lea eax,ModEntry
	push eax
	push hSnap
	apiproc _Module32Next
	.IF eax!=0 
		jmp NextMod
	.ENDIF
	push hSnap
	apiproc _CloseHandle
	mov eax,1
	endproc
	ret
EditIATGlobal endp
;===============================================================================;


;===============================================================================;
; EditIATLocal							
;:
;    IAT   
;: Address     
;	ModName     , IAT    .   .
;	Orig   ,  
;	New -   
;	ModHandle   ,     . ,  KERNEL32.DLL
;: 1 - , 0 -      
;===============================================================================;
EditIATLocal proc ModName:DWORD, Orig:DWORD, New:DWORD, ModHandle:DWORD,Delta:DWORD
LOCAL OldProtect:DWORD
;   
	startproc
	mov ebx,Delta
	mov eax,ModHandle
	assume eax:ptr IMAGE_DOS_HEADER
	add eax,[eax].e_lfanew
	add eax,4
	add eax,sizeof IMAGE_FILE_HEADER	
	mov edi,eax
	assume edi:ptr IMAGE_OPTIONAL_HEADER
	lea edi,[edi].DataDirectory
	mov eax,edi
;   
	assume eax:ptr IMAGE_DATA_DIRECTORY
	lea eax,[eax+(sizeof IMAGE_DATA_DIRECTORY)*IMAGE_DIRECTORY_ENTRY_IMPORT]
	.IF dword ptr [eax]==0
		endproc
		ret;  
	.ENDIF
	mov esi,ModHandle
	add esi,dword ptr [eax]; esi -   
	assume esi:PTR IMAGE_IMPORT_DESCRIPTOR
NextDLL:;    
	.IF [esi].Name1==NULL;  ?
		mov eax,FALSE
		endproc
		ret
	.ENDIF 
	mov ecx,[esi].Name1
	add ecx,ModHandle
	push ecx
	push ModName
	apiproc _lstrcmpiA
	.IF EAX!=0
		add esi,sizeof IMAGE_IMPORT_DESCRIPTOR
		jmp NextDLL
	.ENDIF
;   ,    
	mov edi,ModHandle
	add edi,[esi].FirstThunk; EDI - IAT
	assume edi:PTR IMAGE_THUNK_DATA
NextFunction:;   
	.IF [edi].u1.Function==0;IAT 
		add esi,sizeof IMAGE_IMPORT_DESCRIPTOR
		jmp NextDLL
	.ENDIF
	mov eax,[edi].u1.Function
	.IF Orig==eax;!!!
		lea eax,OldProtect
		push eax
		push PAGE_EXECUTE_READWRITE
		push 4
		push edi
		apiproc _VirtualProtect;    

		apiproc _GetCurrentProcess
		mov ecx,eax
		lea eax,New
		push NULL
		push 4
		push eax
		push edi
		push ecx
		apiproc _WriteProcessMemory
		lea eax,OldProtect
		push eax
		push OldProtect
		push 4
		push edi
		apiproc _VirtualProtect;  
		endproc
		mov eax,TRUE
		ret
	.ENDIF	
	add edi,sizeof IMAGE_THUNK_DATA
	jmp NextFunction
EditIATLocal endp
;===============================================================================;